#BEGIN COPYRIGHT
#*************************************************************************
#
# Licensed Materials - Property of IBM
# 5725-C94, 5725-C95, 5725-C96
# (C) Copyright IBM Corporation 2011. All Rights Reserved.
# US Government Users Restricted Rights- Use, duplication or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
#
#*************************************************************************
#END COPYRIGHT

from java.lang import System, String
import sys

print "*************************************************************************************"
print "start: init"
print ""

fileSeparator = System.getProperty("file.separator");
configUtilsScript = System.getProperty("was.install.root") + fileSeparator + "util" + fileSeparator + "config" + fileSeparator + "admin" + fileSeparator + "configUtils.py"
print "load configuration utils from ", configUtilsScript
execfile(configUtilsScript);

print ""
print "end: init"

def canApplicationBeViewed(applicationName):
    print ""
    canView = "False"

    try:
        AdminApp.view(applicationName);
        print "The application named ", applicationName, " can be viewed"
        canView = "True"
    except:
        # Ignore exception if can not be viewed
        print "Unable to view the application. The exception type is: ", sys.exc_type, ". The exception description is: ", sys.exc_value
        print "The application named ", applicationName, " can not be viewed"

    print ""
    print "The value of canView is ", canView
    return canView;    
#endDef

def isModuleAdded(applicationName, moduleName):
    print ""
    isAdded = "False"

    try:
        modulesList = getObjectArray(AdminApp.listModules(applicationName));
        print "modulesList : ", modulesList
        
        for currentModuleName in modulesList:
            print ""
            print "The value of currentModuleName is ", currentModuleName
            
            stringValueCurrentModuleName = String(currentModuleName);
            
            if (stringValueCurrentModuleName.indexOf(String(moduleName)) >=0 ):
                isAdded = "True";
                break;

    except:
        # Ignore exception if not installed
        print "Unable to determine whether the module is already added or not. The exception type is: ", sys.exc_type, ". The exception description is: ", sys.exc_value

    print ""
    print "The value of isAdded is ", isAdded
    return isAdded;    
#endDef

def removeModule(applicationName, moduleName):
    print ""

    try:
        isApplicationExist = canApplicationBeViewed(applicationName);
        
        if (isApplicationExist == "True"):
            isModuleAlreadyAdded = isModuleAdded(applicationName, moduleName);
            
            if (isModuleAlreadyAdded == "True"):
                updateParameters = "[-operation delete -contenturi " + moduleName + "]";
                AdminApp.update(applicationName, "modulefile", updateParameters);
                AdminConfig.save();                

    except:
            # Ignore exception if not installed
            print "Unable to remove the module. The exception type is: ", sys.exc_type, ". The exception description is: ", sys.exc_value

    print ""
#endDef

#*******************************************************************************************************
# main
#*******************************************************************************************************
print "*************************************************************************************"
print "Start: remove an Administration Console module"
print ""
print ""


try:
    cellType = getCellType();

    applicationName = "isclite";

    moduleName = sys.argv[0]
    print "The value of moduleName is " + moduleName

    if (cellType == "STANDALONE"):
        print "Configuring stand-alone profile."
        print ""
        removeModule(applicationName, moduleName);
    elif (cellType == "DISTRIBUTED"):
        print "Updating the distributed (dmgr or customized) profile"
        # check whether the local node is a deployment manager Node
        isDMgrNode = isDMgrNode();

        if (isDMgrNode != "False"):
            print "Updating the distributed dmgr profile"
            removeModule(applicationName, moduleName);
        else:
            print "The distributed custom profile does not need an update."
except:
        print ""
        print "*************************************************************************************"
        print "The module can not be removed from the application. The exception type is: ", sys.exc_type, ". The exception description is: ", sys.exc_value
        print "*************************************************************************************"
        print ""

print ""
print "End: remove an Administration Console module"
print "*************************************************************************************"
